︠6d2cee92-2fb6-48ad-ba11-41eaf8683b2bi︠
%html
<h1>Gradients</h1>
<p>Based on material from Ben Woodruff</p>
<p>It is simple to calculate the gradient of a function.</p>

︡0f59ed88-30e2-469d-be1c-80cffbe31c87︡{"html": "<h1>Gradients</h1>\r\n<p>Based on material from Ben Woodruff</p>\r\n<p>It is simple to calculate the gradient of a function.</p>"}︡
︠2382cd43-e099-4a29-b468-112eddbe446a︠
f(x,y)=9-x^2-y^2
xbounds=(x,-3,3)
ybounds=(y,-3,3)
plot3d(f(x,y), xbounds,ybounds)
︡0121b864-9709-4b80-a751-3be59ffc450f︡︡
︠0c18e9f5-5a6b-4768-bb38-3bec6a82dedb︠
h=f.gradient()
h(x,y)
︡18f228e1-4122-4a9a-b302-f33e974b584e︡{"stdout": "(-2*x, -2*y)"}︡
︠0a52fcd8-e548-4819-8ef5-13fb04a28962i︠
%html
<p>We can plot the gradient field easily as well.</p>

︡b378914d-2133-4b2c-954a-64077f282d44︡{"html": "<p>We can plot the gradient field easily as well.</p>"}︡
︠e1a235a0-8d43-4d84-8b7f-b69f5bdc4f90︠
f(x,y)=9-x^2-y^2
xbounds=(x,-3,3)
ybounds=(y,-3,3)

h=f.gradient()
plot_vector_field(h(x,y), xbounds, ybounds,aspect_ratio=1)
︡e7dc1161-adc7-49ae-bb12-cfca74fd7152︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠08fd525e-da45-4405-a488-36c8806112bci︠
%html
<p>We can also plot the level curves (i.e., a contour plot) on top of the gradient field, so that we can see that the gradient is always normal (i.e., perpendicular) to the level curve.</p>

︡7e337c68-331f-4685-818d-73d9684baf09︡{"html": "<p>We can also plot the level curves (i.e., a contour plot) on top of the gradient field, so that we can see that the gradient is always normal (i.e., perpendicular) to the level curve.</p>"}︡
︠6e7271ec-4415-44fc-b57d-dfe93efe904f︠
f(x,y)=9-x^2-y^2
xbounds=(x,-3,3)
ybounds=(y,-3,3)

h=f.gradient()
contour_plot(f(x,y), xbounds, ybounds,fill=False,aspect_ratio=1)+plot_vector_field(h(x,y), xbounds, ybounds)
︡f2bdb209-f246-48da-907a-46c05ee9d649︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠18a9d8ca-4599-470a-b8d1-9600febde8bai︠
%html
<p>This all holds for functions from $\RR^3 \to \RR$ as well.&nbsp; However, in this case, the function has "level surfaces", and the gradient is a 3-dimensional vector.</p>

︡6316730b-6cd1-4603-b9c4-35afb8138504︡{"html": "<p>This all holds for functions from $\\RR^3 \\to \\RR$ as well.&nbsp; However, in this case, the function has \"level surfaces\", and the gradient is a 3-dimensional vector.</p>"}︡
︠516a4b26-a0f2-475a-b806-703a6d5401cc︠
f(x,y,z)=x^2-y^2+z
xbounds=(x,-3,3)
ybounds=(y,-3,3)
zbounds=(z,-3,3)
︡ec985f5e-11de-45b4-8ae3-640370458665︡︡
︠bd3de120-c99c-411b-99b7-c54e5c76fb79︠
h=f.gradient()
h(x,y,z)
︡229b5422-d603-4c83-bb15-296ba5b42511︡{"stdout": "(2*x, -2*y, 1)"}︡
︠ba5e7b23-88cc-4d9b-9c0d-da5e9f2a5159i︠
%html
<p>Evaluate the cell below to get the plot_vector_field3d command, which allows us to plot this 3d gradient field.</p>

︡fad667d6-cbb9-435e-a6cb-6b1813215d41︡{"html": "<p>Evaluate the cell below to get the plot_vector_field3d command, which allows us to plot this 3d gradient field.</p>"}︡
︠310838d7-c8a7-4789-b027-eaa9fdbd6b4ba︠
%auto
from matplotlib.cm import get_cmap
from matplotlib.colors import LinearSegmentedColormap
from sage.plot.misc import setup_for_eval_on_grid

def plot_vector_field3d(functions, xrange, yrange, zrange, 
                        plot_points=5, colors='jet', center_arrows=False,**kwds):
    r"""
    Plot a 3d vector field

    INPUT:

    - ``functions`` - a list of three functions, representing the x-,
      y-, and z-coordinates of a vector

    - ``xrange``, ``yrange``, and ``zrange`` - three tuples of the
      form (var, start, stop), giving the variables and ranges for each axis

    - ``plot_points`` (default 5) - either a number or list of three
      numbers, specifying how many points to plot for each axis

    - ``colors`` (default 'jet') - a color, list of colors (which are
      interpolated between), or matplotlib colormap name, giving the coloring
      of the arrows.  If a list of colors or a colormap is given,
      coloring is done as a function of length of the vector

    - ``center_arrows`` (default False) - If True, draw the arrows
      centered on the points; otherwise, draw the arrows with the tail
      at the point

    - any other keywords are passed on to the plot command for each arrow

    EXAMPLES::
    
        sage: x,y,z=var('x y z')
        sage: plot_vector_field3d((x*cos(z),-y*cos(z),sin(z)), (x,0,pi), (y,0,pi), (z,0,pi))
        sage: plot_vector_field3d((x*cos(z),-y*cos(z),sin(z)), (x,0,pi), (y,0,pi), (z,0,pi),colors=['red','green','blue'])
        sage: plot_vector_field3d((x*cos(z),-y*cos(z),sin(z)), (x,0,pi), (y,0,pi), (z,0,pi),colors='red')
        sage: plot_vector_field3d((x*cos(z),-y*cos(z),sin(z)), (x,0,pi), (y,0,pi), (z,0,pi),plot_points=4)
        sage: plot_vector_field3d((x*cos(z),-y*cos(z),sin(z)), (x,0,pi), (y,0,pi), (z,0,pi),plot_points=[3,5,7])
        sage: plot_vector_field3d((x*cos(z),-y*cos(z),sin(z)), (x,0,pi), (y,0,pi), (z,0,pi),center_arrows=True)
    """
    (ff,gg,hh), ranges = setup_for_eval_on_grid(functions, [xrange, yrange, zrange], plot_points)
    xpoints, ypoints, zpoints = [srange(*r, include_endpoint=True) for r in ranges]
    points = [vector((i,j,k)) for i in xpoints for j in ypoints for k in zpoints]
    vectors = [vector((ff(*point), gg(*point), hh(*point))) for point in points]
    
    try:
        cm=get_cmap(colors)
        assert(cm is not None)
    except (TypeError, AssertionError):
        if isinstance(colors, (list, tuple)):
            cm=LinearSegmentedColormap.from_list('mymap',colors)
        else:
            cm = lambda x: colors
                
    max_len = max(v.norm() for v in vectors)
    scaled_vectors = [v/max_len for v in vectors]
    
    if center_arrows:
        return sum([plot(v,color=cm(v.norm()),**kwds).translate(p-v/2) for v,p in zip(scaled_vectors, points)])
    else:
        return sum([plot(v,color=cm(v.norm()),**kwds).translate(p) for v,p in zip(scaled_vectors, points)])
︡20ec5c36-57ff-49bd-a063-50d6df30c45d︡︡
︠31419a4a-5b49-4d01-b7ea-6fcca0b339e0i︠
%html
<p>You'll notice that the gradient vectors in the plot below are all perpendicular to the level surfaces.</p>

︡cfff373f-d1b5-4da7-b733-667f965b8899︡{"html": "<p>You'll notice that the gradient vectors in the plot below are all perpendicular to the level surfaces.</p>"}︡
︠2e31fff8-af35-4190-b420-15e002cc7c1f︠
implicit_plot3d(f(x,y,z), xbounds, ybounds, zbounds, contour=[-4,0,4],opacity=0.8)+plot_vector_field3d(h(x,y,z), xbounds, ybounds, zbounds)
︡b84e4515-0019-46a2-b909-3338acd4574c︡︡
︠45253fed-7bfc-44e6-bdc4-af437f54a32ei︠
%html
<h1>Directional Derivatives</h1>
<p>A directional derivative is just the gradient dotted with a unit vector in the direction. Remember to evaluate at the point.</p>

︡ea41a128-62fc-440d-aed1-69653389d37f︡{"html": "<h1>Directional Derivatives</h1>\r\n<p>A directional derivative is just the gradient dotted with a unit vector in the direction. Remember to evaluate at the point.</p>"}︡
︠8b953fcb-7658-4bff-a259-202e6aa4b3c0︠
f(x,y)=9-x^2-y^2
u=vector([sqrt(3)/2, -1/2])
pt=(1/2, sqrt(3)/2)
directional_derivative = f.gradient()*(u/norm(u))
directional_derivative(x,y)
︡72c6cd10-de46-4b77-9aaf-31c37bd5c27e︡{"stdout": "-sqrt(3)*x + y"}︡
︠4487d610-a257-4bef-abe3-089d3daa512ei︠
%html
<p>To evaluate it at a point, just do the following.&nbsp; Literally, this is taking the first thing in point (the $x$-coordinate) and making that the first argument of the function, and so on.</p>

︡0149d990-0edd-43fd-8335-ac3be9c109e8︡{"html": "<p>To evaluate it at a point, just do the following.&nbsp; Literally, this is taking the first thing in point (the $x$-coordinate) and making that the first argument of the function, and so on.</p>"}︡
︠ee8738ee-21fc-4568-bf3e-362da197407a︠
directional_derivative(*pt)
︡7e498f6d-46d5-424f-92cc-a5b34f0e4150︡{"stdout": "0"}︡
︠b61aa198-cc05-4160-bb30-a89e935ca284i︠
%html
<p>In the interact below, the directional derivative is the slope of the green tangent line.&nbsp; The cross-section in the direction is the red curve, and the gradient vector is the orange vector.</p>

︡29e530a5-0fb3-48a8-ba69-00b1fbf5dbe1︡{"html": "<p>In the interact below, the directional derivative is the slope of the green tangent line.&nbsp; The cross-section in the direction is the red curve, and the gradient vector is the orange vector.</p>"}︡
︠f89403ea-f941-49d7-a44d-272614fffe77︠
var('x,y,t,z')
f(x,y)=sin(x)*cos(y)

pif = float(pi)

line_thickness=3
surface_color='blue'
plane_color='purple'
line_color='red'
tangent_color='green'
gradient_color='orange'

@interact
def myfun(location=input_grid(1, 2, default=[0,0], label = "Location (x,y)", width=2), angle=slider(0, 2*pif, label = "Angle"), 
show_surface=("Show surface", True)):
    location3d = vector(location[0]+[0])
    location = location3d[0:2]
    direction3d = vector(RDF, [cos(angle), sin(angle), 0])
    direction=direction3d[0:2]
    cos_angle = math.cos(angle)
    sin_angle = math.sin(angle)
    df = f.gradient()
    direction_vector=line3d([location3d, location3d+direction3d], arrow_head=True, rgbcolor=line_color, thickness=line_thickness)
    curve_point = (location+t*direction).list()
    curve = parametric_plot(curve_point+[f(*curve_point)], (t,-3,3),color=line_color,thickness=line_thickness)
    plane = parametric_plot((cos_angle*x+location[0],sin_angle*x+location[1],t), (x, -3,3), (t,-3,3),opacity=0.8, color=plane_color)
    pt = point3d(location3d.list(),color='green', size=10)

    tangent_line = parametric_plot((location[0]+t*cos_angle, location[1]+t*sin_angle, f(*location)+t*df(*location)*(direction)), (t, -3,3), thickness=line_thickness, color=tangent_color)
    picture3d = direction_vector+curve+plane+pt+tangent_line

    picture2d = contour_plot(f(x,y), (x,-3,3),(y,-3,3), plot_points=100)
    picture2d += arrow(location.list(), (location+direction).list()) 
    picture2d += point(location.list(),rgbcolor='green',pointsize=40)
    if show_surface:
        picture3d += plot3d(f(x,y), (x,-3,3),(y,-3,3),opacity=0.7)
        
    dff = df(location[0], location[1])
    dff3d = vector(RDF,dff.list()+[0])
    picture3d += line3d([location3d, location3d+dff3d], arrow_head=True, rgbcolor=gradient_color, thickness=line_thickness)
    picture2d += arrow(location.list(), (location+dff).list(), rgbcolor=gradient_color, width=line_thickness)
    show(picture3d,aspect=[1,1,1], axes=True)
    show(picture2d, aspect_ratio=1)
︡3f66f289-b7fb-4ed1-8804-cc6b88a0fb9e︡︡
︠e4d3f4fb-1ba0-4225-b864-5795c54250c6i︠
%html
<p><span class="typeset"><span class="scale"><span style="position: relative;">&nbsp;</span></span></span></p>
<h1>The 2nd Derivative test</h1>
<p>The second derivative test looks at the eigenvalues of the Hessian matrix evaluated at critical points.</p>

︡5a2d2a7b-ae6e-4e21-a482-999231aecb72︡{"html": "<p><span class=\"typeset\"><span class=\"scale\"><span style=\"position: relative;\">&nbsp;</span></span></span></p>\r\n<h1>The 2nd Derivative test</h1>\r\n<p>The second derivative test looks at the eigenvalues of the Hessian matrix evaluated at critical points.</p>"}︡
︠fe44ea99-3163-465e-a7f3-8793fd37ed8f︠
def illustrate_test(f, fvals=(-5,5), tvals=(-3,3)):
    """
    Return a table of critical points, eigenvalues, and eigenvectors, plus a 3D graph illustrating the curvature at each critical point.
    
    INPUTS:
      f -- a function.  Usually this should be a callable function, defined like f(x,y)=x^2+y^2, for example.
      fvals (default (-5,5)) -- minimum and maximum values for the function plot
      tvals (default (-3,3)) -- minimum and maximum values for the parameter in the curves at each critical point

    EXAMPLES:
        sage: var('x,y')
        sage: f(x,y)=-x^2+y^2
        sage: table, graph=illustrate_test(f)
        sage: print table
        sage: show(graph)
        
        sage: var('x,y')
        sage: f(x,y)=x*y*exp((-x^2-y^2)/3)
        sage: table, graph=illustrate_test(f)
        sage: print table
        sage: show(graph)
    """
    line_thickness=3
    surface_color='blue'
    line_color = ['red','blue']
    x,y,t=var('x,y,t')
    tmin, tmax = tvals
    fmin, fmax = fvals
    f_parametric = vector([x,y,f(x,y)])
    picture = plot3d(f,(x,fmin,fmax),(y,fmin,fmax), opacity=0.3, surface_color=surface_color)
    hessian=f(x,y).hessian()
    solns=solve([eqn(x,y)==0 for eqn in f.gradient()],[x,y], solution_dict=True)

    table=[['Color','Critical Point', 'Eigenvalue', 'Eigenvector']]
    pictures=[]
    i=0
    for solution in [s for s in solns if s[x] in RR and s[y] in RR]:
        soln = dict([(key,RDF(val)) for key,val in solution.items()])
        critical_point = f_parametric(soln)
        hessian_at_point = hessian(soln).change_ring(RDF)
        evals,evecs=hessian_at_point.eigenvectors_right()
        picture += point3d(critical_point.list(), color='green', size=10)
        for eval,evec in zip(evals,evecs.columns()):
            direction_plot = evec.plot(width=line_thickness,color=line_color[i%2]).plot3d().translate(critical_point)    
            curve_formula = f_parametric(x=soln[x]+t*evec[0],y=soln[y]+t*evec[1])
            curve = parametric_plot(curve_formula, (t,tmin,tmax),color=line_color[i%2],thickness=line_thickness)
            picture+=curve+direction_plot
            pictures += [curve]
            table.append([line_color[i%2],(critical_point), eval, (evec)])
            i+=1

    return table, picture
︡d91717a5-6f85-4cc6-8120-ea8987f3ba17︡︡
︠e75f3669-6d7a-4ffc-bad8-8cd74ccfccb5︠
f(x,y)=-x^2+y^2
table, graph=illustrate_test(f)
html.table(table,header=True)
show(graph)
︡937553ed-71ff-4b71-9e0e-89c59722cdc5︡{"html": "\n<div class=\"notruncate\">\n<table class=\"table_form\">\n<tbody>\n<tr>\n<th>Color</th>\n<th>Critical Point</th>\n<th>Eigenvalue</th>\n<th>Eigenvector</th>\n</tr>\n<tr class =\"row-a\">\n<td>red</td>\n<td><span class=\"math\">\\left(0.0,0.0,0\\right)</span></td>\n<td><span class=\"math\">-2.0</span></td>\n<td><span class=\"math\">\\left(1.0,0.0\\right)</span></td>\n</tr>\n<tr class =\"row-b\">\n<td>blue</td>\n<td><span class=\"math\">\\left(0.0,0.0,0\\right)</span></td>\n<td><span class=\"math\">2.0</span></td>\n<td><span class=\"math\">\\left(0.0,1.0\\right)</span></td>\n</tr>\n</tbody>\n</table>\n</div>\n"}︡
︠4475b5b5-c593-49ee-b8ed-adb84458a18a︠
f(x,y)=x*y*exp((-x^2-y^2)/3)
table, graph=illustrate_test(f)
html.table(table,header=True)
show(graph)
︡c743a277-ef55-4b33-a6ee-daa5ffdfac12︡{"html": "\n<div class=\"notruncate\">\n<table class=\"table_form\">\n<tbody>\n<tr>\n<th>Color</th>\n<th>Critical Point</th>\n<th>Eigenvalue</th>\n<th>Eigenvector</th>\n</tr>\n<tr class =\"row-a\">\n<td>red</td>\n<td><span class=\"math\">\\left(0.0,0.0,0\\right)</span></td>\n<td><span class=\"math\">1.0</span></td>\n<td><span class=\"math\">\\left(0.707106781187,0.707106781187\\right)</span></td>\n</tr>\n<tr class =\"row-b\">\n<td>blue</td>\n<td><span class=\"math\">\\left(0.0,0.0,0\\right)</span></td>\n<td><span class=\"math\">-1.0</span></td>\n<td><span class=\"math\">\\left(-0.707106781187,0.707106781187\\right)</span></td>\n</tr>\n<tr class =\"row-a\">\n<td>red</td>\n<td><span class=\"math\">\\left(-1.22474487139,-1.22474487139,0.551819161757\\right)</span></td>\n<td><span class=\"math\">-0.735758882343</span></td>\n<td><span class=\"math\">\\left(1.0,0.0\\right)</span></td>\n</tr>\n<tr class =\"row-b\">\n<td>blue</td>\n<td><span class=\"math\">\\left(-1.22474487139,-1.22474487139,0.551819161757\\right)</span></td>\n<td><span class=\"math\">-0.735758882343</span></td>\n<td><span class=\"math\">\\left(0.0,1.0\\right)</span></td>\n</tr>\n<tr class =\"row-a\">\n<td>red</td>\n<td><span class=\"math\">\\left(1.22474487139,-1.22474487139,-0.551819161757\\right)</span></td>\n<td><span class=\"math\">0.735758882343</span></td>\n<td><span class=\"math\">\\left(1.0,0.0\\right)</span></td>\n</tr>\n<tr class =\"row-b\">\n<td>blue</td>\n<td><span class=\"math\">\\left(1.22474487139,-1.22474487139,-0.551819161757\\right)</span></td>\n<td><span class=\"math\">0.735758882343</span></td>\n<td><span class=\"math\">\\left(0.0,1.0\\right)</span></td>\n</tr>\n<tr class =\"row-a\">\n<td>red</td>\n<td><span class=\"math\">\\left(-1.22474487139,1.22474487139,-0.551819161757\\right)</span></td>\n<td><span class=\"math\">0.735758882343</span></td>\n<td><span class=\"math\">\\left(1.0,0.0\\right)</span></td>\n</tr>\n<tr class =\"row-b\">\n<td>blue</td>\n<td><span class=\"math\">\\left(-1.22474487139,1.22474487139,-0.551819161757\\right)</span></td>\n<td><span class=\"math\">0.735758882343</span></td>\n<td><span class=\"math\">\\left(0.0,1.0\\right)</span></td>\n</tr>\n<tr class =\"row-a\">\n<td>red</td>\n<td><span class=\"math\">\\left(1.22474487139,1.22474487139,0.551819161757\\right)</span></td>\n<td><span class=\"math\">-0.735758882343</span></td>\n<td><span class=\"math\">\\left(1.0,0.0\\right)</span></td>\n</tr>\n<tr class =\"row-b\">\n<td>blue</td>\n<td><span class=\"math\">\\left(1.22474487139,1.22474487139,0.551819161757\\right)</span></td>\n<td><span class=\"math\">-0.735758882343</span></td>\n<td><span class=\"math\">\\left(0.0,1.0\\right)</span></td>\n</tr>\n</tbody>\n</table>\n</div>\n"}︡
︠42fbe206-db79-485f-ace5-e660b4ac9f53︠
var('x,y')
f(x,y)=x^3 - y^3 - 2*x*y + 6
table, graph=illustrate_test(f, fvals=(-1,1), tvals=(-1,1))
html.table(table,header=True)
show(graph)
︡61cd7ae5-490d-4308-8125-60712f424dc7︡{"html": "\n<div class=\"notruncate\">\n<table class=\"table_form\">\n<tbody>\n<tr>\n<th>Color</th>\n<th>Critical Point</th>\n<th>Eigenvalue</th>\n<th>Eigenvector</th>\n</tr>\n<tr class =\"row-a\">\n<td>red</td>\n<td><span class=\"math\">\\left(-0.666666666667,0.666666666667,6.2962962963\\right)</span></td>\n<td><span class=\"math\">-2.0</span></td>\n<td><span class=\"math\">\\left(0.707106781187,-0.707106781187\\right)</span></td>\n</tr>\n<tr class =\"row-b\">\n<td>blue</td>\n<td><span class=\"math\">\\left(-0.666666666667,0.666666666667,6.2962962963\\right)</span></td>\n<td><span class=\"math\">-6.0</span></td>\n<td><span class=\"math\">\\left(0.707106781187,0.707106781187\\right)</span></td>\n</tr>\n<tr class =\"row-a\">\n<td>red</td>\n<td><span class=\"math\">\\left(0.0,0.0,6\\right)</span></td>\n<td><span class=\"math\">2.0</span></td>\n<td><span class=\"math\">\\left(0.707106781187,-0.707106781187\\right)</span></td>\n</tr>\n<tr class =\"row-b\">\n<td>blue</td>\n<td><span class=\"math\">\\left(0.0,0.0,6\\right)</span></td>\n<td><span class=\"math\">-2.0</span></td>\n<td><span class=\"math\">\\left(0.707106781187,0.707106781187\\right)</span></td>\n</tr>\n</tbody>\n</table>\n</div>\n"}︡
︠f09db140-ea57-4bc5-a346-ba30dd7b4160i︠
%html
<h1>Lagrange Multipliers</h1>
<p>We'll work out an example problem.</p>
<p>Find the maximum and minimum temperatures on the circle $x^2+y^2=1$  if the temperature of a point $(x,y)$ is $T(x,y)=4+x^2-y$.</p>

︡d0b5166f-cbee-4e9a-832c-b706dbac0eda︡{"html": "<h1>Lagrange Multipliers</h1>\n<p>We'll work out an example problem.</p>\n<p>Find the maximum and minimum temperatures on the circle $x^2+y^2=1$  if the temperature of a point $(x,y)$ is $T(x,y)=4+x^2-y$.</p>"}︡
︠5512d86a-452e-4f0e-a714-12267d644c6c︠
var('x,y,z,t')
T(x,y)=4+x^2-y
g(x,y)=x^2+y^2-1
︡2ec26e29-e271-4bf8-b402-230126b76657︡︡
︠ced64102-0cdf-4b29-b564-9358b2f054c1︠
p=parametric_plot([cos(t), sin(t), T(cos(t), sin(t))], (t, 0, 2*pi),thickness=8,color='black',aspect_ratio=1)
p+=plot3d(T(x,y), (x,-2,2), (y,-2,2),opacity=0.6)
p+=implicit_plot3d(g(x,y)==0,(x,-2,2),(y,-2,10),(z,0,10),aspect_ratio=1,color='red',opacity=0.6) # The y-value is set to work around a bug in Sage 4.2
show(p)
︡81b10d29-e8f9-4822-94ba-c80b69f61023︡︡
︠ab79d9ae-d73b-48e5-9148-27ae766ad372i︠
%html
<p>Another way to imagine it is just as the constraint function (the circle), drawn on the temperature function.</p>

︡f87fd10c-0a33-467f-b0ef-3e0d35640b9c︡{"html": "<p>Another way to imagine it is just as the constraint function (the circle), drawn on the temperature function.</p>"}︡
︠0577f6a5-3ded-4a15-b396-94147c59c4dd︠
p=parametric_plot([cos(t), sin(t), T(cos(t), sin(t))], (t, 0, 2*pi),thickness=5)
p+=plot3d(T(x,y), (x,-2,2), (y,-2,2),opacity=0.4)
p+=points([[sqrt(3/4),-1/2,21/4],[-sqrt(3/4),-1/2,21/4]],size=10,color='green')
p+=point([0,1,3],size=10,color='red')
p+=circle((0,0),1,color='black').plot3d()
show(p,aspect_ratio=1)
︡c1142d3b-7537-4d89-b81a-4cfbab944d05︡︡
︠83f3f3a7-2266-4516-b741-1c98e59abbdf︠
p=contour_plot(T(x,y), (x,-2,2),(y,-2,2),contours=40,fill=False)
p+=implicit_plot(g(x,y)==0, (x,-2,2), (y,-2,2),cmap=['blue'])
p+=points([[sqrt(3/4),-1/2],[-sqrt(3/4),-1/2]],pointsize=50,color='green')
p+=point([0,1],pointsize=50,color='red')
show(p,aspect_ratio=1)
︡df5d9fd0-0bdb-4ad7-85a7-5f8e25391b57︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠7d64d68c-5ccc-4f31-80cc-da8a16770b92i︠
%html
<p>Calculate the Lagrangian $L(x,y,\lambda)=T(x,y)-\lambda*g(x,y)$.&nbsp; We'll  use "lambda_" for $\lambda$ because we can't use the word "lambda" in  python/Sage (it means something different than what we want).</p>

︡8288bd2c-f689-4c7c-aaff-fd9cb1a0bfe1︡{"html": "<p>Calculate the Lagrangian $L(x,y,\\lambda)=T(x,y)-\\lambda*g(x,y)$.&nbsp; We'll  use \"lambda_\" for $\\lambda$ because we can't use the word \"lambda\" in  python/Sage (it means something different than what we want).</p>"}︡
︠443a1c77-0eb0-4394-a0eb-21800ff0ed37︠
var('lambda_')
L(x,y,lambda_)=T(x,y)-lambda_*g(x,y)
︡d7f06485-d315-4195-84af-116edf53177d︡︡
︠4a37ab26-a66b-4c89-88c4-f4c25d3a67d2︠
gradL=L.gradient()(x,y,lambda_)
gradL
︡4872a92d-f863-4269-a84c-2e20989ee607︡{"stdout": "(-2*lambda_*x + 2*x, -2*lambda_*y - 1, -x^2 - y^2 + 1)"}︡
︠66f103cd-7f49-400b-9856-c0e4747adc76i︠
%html
<p>We get four solutions to the three equations given by $\nabla L=\vec 
0$.</p>

︡c734133b-c0b4-466f-a8e6-23eade0343c7︡{"html": "<p>We get four solutions to the three equations given by $\\nabla L=\\vec \r\n0$.</p>"}︡
︠19573f2e-c779-4d1a-b46c-9947d08ea571︠
solve([gradL[0]==0,gradL[1]==0,gradL[2]==0], [x,y,lambda_])
︡9ddbc820-6406-44e8-a340-40c7acb34ad1︡{"stdout": "[[x == 0, y == -1, lambda_ == (1/2)], [x == 0, y == 1, lambda_ == (-1/2)], [x == 1/2*sqrt(3), y == (-1/2), lambda_ == 1], [x == -1/2*sqrt(3), y == (-1/2), lambda_ == 1]]"}︡
︠49c52fe0-fb9d-42dd-b4c1-9f7a6a937cadi︠
%html
<p>Now let's plug each of these $(x,y)$ values in to $T(x,y)$ to find the global maxima and minima.</p>

︡1bff8edb-3b17-4cb6-a3c4-ed4b65560841︡{"html": "<p>Now let's plug each of these $(x,y)$ values in to $T(x,y)$ to find the global maxima and minima.</p>"}︡
︠97db7d6f-606f-4fae-a821-e21e390f2543︠
T(0,1)
︡51dc3cf2-caec-4513-9e48-3b80d4ed7ad2︡{"stdout": "3"}︡
︠f66d7fce-130d-45ca-9ea1-4e5e09646c08︠
T(0,-1)
︡0ff7e733-fbde-4611-8f7e-e755916fc47a︡{"stdout": "5"}︡
︠f25ef75f-0103-4c6a-ac83-fdd3767440e4︠
T(sqrt(3/4), -1/2)
︡33c2c19c-aa5d-4936-a30d-bc4fd9021d7c︡{"stdout": "21/4"}︡
︠151316b0-e4cb-4dcb-8d38-ffd7c4994352︠
T(-sqrt(3/4), -1/2)
︡e860a5cc-0b47-4718-a647-72e4086a6b2a︡{"stdout": "21/4"}︡
︠489111eb-cba2-4837-a0a5-3084f9eae404i︠
%html
<p>The maximum is therefore at both $(\sqrt{3/4},-1/2)$ and $(-\sqrt{3/4},-1/2)$ (max value $21/4$) and the minimum is at $(0,1)$ (min value 3).</p>

︡9d486ef8-5f61-40d4-a4b2-107943aae3b4︡{"html": "<p>The maximum is therefore at both $(\\sqrt{3/4},-1/2)$ and $(-\\sqrt{3/4},-1/2)$ (max value $21/4$) and the minimum is at $(0,1)$ (min value 3).</p>"}︡
